Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 44824)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 44825)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2010-2012 Oracle Corporation
+ * Copyright (C) 2010-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -101,15 +101,18 @@
 }
 
-int UIMachineLogicFullscreen::hostScreenForGuestScreen(int screenId) const
-{
-    return m_pScreenLayout->hostScreenForGuestScreen(screenId);
-}
-
-#ifdef Q_WS_MAC
-void UIMachineLogicFullscreen::prepareFullscreenConnections()
-{
-    /* Presentation mode connection: */
-    connect(gEDataEvents, SIGNAL(sigPresentationModeChange(bool)),
-            this, SLOT(sltChangePresentationMode(bool)));
+int UIMachineLogicFullscreen::hostScreenForGuestScreen(int iScreenId) const
+{
+    return m_pScreenLayout->hostScreenForGuestScreen(iScreenId);
+}
+
+#ifdef Q_WS_MAC
+void UIMachineLogicFullscreen::sltChangePresentationMode(bool /* fEnabled */)
+{
+    setPresentationModeEnabled(true);
+}
+
+void UIMachineLogicFullscreen::sltScreenLayoutChanged()
+{
+    setPresentationModeEnabled(true);
 }
 #endif /* Q_WS_MAC */
@@ -166,4 +169,13 @@
 }
 
+#ifdef Q_WS_MAC
+void UIMachineLogicFullscreen::prepareFullscreenConnections()
+{
+    /* Presentation mode connection: */
+    connect(gEDataEvents, SIGNAL(sigPresentationModeChange(bool)),
+            this, SLOT(sltChangePresentationMode(bool)));
+}
+#endif /* Q_WS_MAC */
+
 void UIMachineLogicFullscreen::cleanupMachineWindows()
 {
@@ -191,14 +203,4 @@
 
 #ifdef Q_WS_MAC
-void UIMachineLogicFullscreen::sltChangePresentationMode(bool /* fEnabled */)
-{
-    setPresentationModeEnabled(true);
-}
-
-void UIMachineLogicFullscreen::sltScreenLayoutChanged()
-{
-    setPresentationModeEnabled(true);
-}
-
 void UIMachineLogicFullscreen::setPresentationModeEnabled(bool fEnabled)
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h	(revision 44824)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.h	(revision 44825)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2010-2012 Oracle Corporation
+ * Copyright (C) 2010-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -35,5 +35,5 @@
     /* Constructor/destructor: */
     UIMachineLogicFullscreen(QObject *pParent, UISession *pSession);
-    virtual ~UIMachineLogicFullscreen();
+    ~UIMachineLogicFullscreen();
 
     /* Check if this logic is available: */
@@ -43,12 +43,13 @@
     void prepare();
 
-    int hostScreenForGuestScreen(int screenId) const;
+    /* Multi-screen stuff: */
+    int hostScreenForGuestScreen(int iScreenId) const;
 
 private slots:
 
-#ifdef RT_OS_DARWIN
+#ifdef Q_WS_MAC
     void sltChangePresentationMode(bool fEnabled);
     void sltScreenLayoutChanged();
-#endif /* RT_OS_DARWIN */
+#endif /* Q_WS_MAC */
 
 private:
@@ -62,9 +63,9 @@
 
     /* Cleanup helpers: */
-    void cleanupMachineWindows();
-    void cleanupActionGroups();
 #ifdef Q_WS_MAC
     //void cleanupCommonConnections() {}
 #endif /* Q_WS_MAC */
+    void cleanupMachineWindows();
+    void cleanupActionGroups();
 
 #ifdef Q_WS_MAC
@@ -72,4 +73,5 @@
 #endif /* Q_WS_MAC */
 
+    /* Variables: */
     UIMultiScreenLayout *m_pScreenLayout;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp	(revision 44824)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp	(revision 44825)
@@ -7,5 +7,5 @@
 
 /*
- * Copyright (C) 2010-2012 Oracle Corporation
+ * Copyright (C) 2010-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -87,7 +87,7 @@
 }
 
-int UIMachineLogicSeamless::hostScreenForGuestScreen(int screenId) const
+int UIMachineLogicSeamless::hostScreenForGuestScreen(int iScreenId) const
 {
-    return m_pScreenLayout->hostScreenForGuestScreen(screenId);
+    return m_pScreenLayout->hostScreenForGuestScreen(iScreenId);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.h	(revision 44824)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.h	(revision 44825)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2010-2012 Oracle Corporation
+ * Copyright (C) 2010-2013 Oracle Corporation
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -35,10 +35,11 @@
     /* Constructor/destructor: */
     UIMachineLogicSeamless(QObject *pParent, UISession *pSession);
-    virtual ~UIMachineLogicSeamless();
+    ~UIMachineLogicSeamless();
 
     /* Check if this logic is available: */
     bool checkAvailability();
 
-    int hostScreenForGuestScreen(int screenId) const;
+    /* Multi-screen stuff: */
+    int hostScreenForGuestScreen(int iScreenId) const;
 
 private:
@@ -52,4 +53,5 @@
     void cleanupActionGroups();
 
+    /* Variables: */
     UIMultiScreenLayout *m_pScreenLayout;
 